#ifndef _COMMANDS_H
#define _COMMANDS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "type_def.h"

// ----------------------
// Helper stuff

#define MAX_TYPE 6
#define MAX_SUBTYPE 100

enum Message{
	BEGIN_CHAR = 0xBE,
	END_CHAR   = 0xED
};

// This should also have double to avoid confusion with float values.
enum DataType
{
	floatType,
	intType,
	stringType
};

// MESSAGE SUBTYPES
struct MessageSubtype{
	char ID;
	char cmdText[100];
	char cmdDataType;
	int (*functionPtr)(unsigned char *command, int dataLen, modular_structs_t *structs);
};

// MESSAGE TYPES
struct MessageType{
	char ID;
	struct MessageSubtype subtypes[MAX_SUBTYPE];
};

int debug(unsigned char *c, int dataLen, modular_structs_t *structs);
int update(unsigned char *c, int dataLen, modular_structs_t *structs);
int beginupdate(unsigned char *c, int dataLen, modular_structs_t *structs);
int logdata(unsigned char *c, int dataLen, modular_structs_t *structs);
int response(unsigned char *packet, int dataLen, modular_structs_t *structs);
int throttleset(unsigned char *c, int dataLen, modular_structs_t *structs);
int setheightp(unsigned char *c, int dataLen, modular_structs_t *structs);
int setheighti(unsigned char *c, int dataLen, modular_structs_t *structs);
int setheightd(unsigned char *c, int dataLen, modular_structs_t *structs);
int setlatp(unsigned char *c, int dataLen, modular_structs_t *structs);
int setlati(unsigned char *c, int dataLen, modular_structs_t *structs);
int setlatd(unsigned char *c, int dataLen, modular_structs_t *structs);
int setlongp(unsigned char *c, int dataLen, modular_structs_t *structs);
int setlongi(unsigned char *c, int dataLen, modular_structs_t *structs);
int setlongd(unsigned char *c, int dataLen, modular_structs_t *structs);
int setpitchp(unsigned char *c, int dataLen, modular_structs_t *structs);
int setpitchi(unsigned char *c, int dataLen, modular_structs_t *structs);
int setpitchd(unsigned char *c, int dataLen, modular_structs_t *structs);
int setrollp(unsigned char *c, int dataLen, modular_structs_t *structs);
int setrolli(unsigned char *c, int dataLen, modular_structs_t *structs);
int setrolld(unsigned char *c, int dataLen, modular_structs_t *structs);
int setyawp(unsigned char *c, int dataLen, modular_structs_t *structs);
int setyawi(unsigned char *c, int dataLen, modular_structs_t *structs);
int setyawd(unsigned char *c, int dataLen, modular_structs_t *structs);
int setpitchratep(unsigned char *c, int dataLen, modular_structs_t *structs);
int setpitchratei(unsigned char *c, int dataLen, modular_structs_t *structs);
int setpitchrated(unsigned char *c, int dataLen, modular_structs_t *structs);
int setrollratep(unsigned char *c, int dataLen, modular_structs_t *structs);
int setrollratei(unsigned char *c, int dataLen, modular_structs_t *structs);
int setrollrated(unsigned char *c, int dataLen, modular_structs_t *structs);
int setyawratep(unsigned char *c, int dataLen, modular_structs_t *structs);
int setyawratei(unsigned char *c, int dataLen, modular_structs_t *structs);
int setyawrated(unsigned char *c, int dataLen, modular_structs_t *structs);
int accelreq(unsigned char *c, int dataLen, modular_structs_t *structs);
int gyroresp(unsigned char *c, int dataLen, modular_structs_t *structs);
int pitchangleresp(unsigned char *c, int dataLen, modular_structs_t *structs);
int rollangleresp(unsigned char *c, int dataLen, modular_structs_t *structs);
int gyroreq(unsigned char *c, int dataLen, modular_structs_t *structs);
int pitchanglereq(unsigned char *c, int dataLen, modular_structs_t *structs);
int rollanglereq(unsigned char *c, int dataLen, modular_structs_t *structs);
int accelresp(unsigned char *c, int dataLen, modular_structs_t *structs);

// TODO add in string to be read from the command line when sending a subtype of message
extern struct MessageType MessageTypes[MAX_TYPE];

#endif
